﻿import es
import langlib
import playerlib
import popuplib

addon = es.import_addon("soccer_mod_2011/admin/settings")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "admin/settings/messages_settings_match_names.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "admin/settings/popup_settings_match_names.ini")

settings_names = ["default_name_t", "default_name_ct", "default_short_name_t", "default_short_name_ct"]

# ******************** Load ********************
def load():
	for item in settings_names:
		es.set("sm_match_%s" % (item), es.keygetvalue("soccer_mod_settings", "match", "%s" % (item)))

	popup = popuplib.create("sm_popup_admin_settings_match_names")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	for i in range(0, len(settings_names)):
		popup.addline("->%s. %s: %s" % (i + 1, popup_text(settings_names[i]), es.ServerVar("sm_match_%s" % (settings_names[i]))))
		popup.select(i + 1, change_setting_names)

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(5, 9):
		popup.submenu(i, "sm_popup_admin_settings_match_names")

	popup.submenu(9, "sm_popup_admin_settings_match")

	es.addons.registerSayFilter(filter)

# ******************** Popup choice ********************
def change_setting_names(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
		es.keycreate("sm_keygroup_set", player.steamid)

	es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_match_%s" % (settings_names[choice - 1]))

	es.tell(userid, "#green", messages_text("type_%s" % (settings_names[choice - 1]), tokens, player.get("lang")))

# ******************** Say filter ********************
def filter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		text = text.strip('"')

		if type == "settings_match_default_name_t":
			addon.set_string(userid, text, "match_names", "match", "default_name_t", 25, "sm_popup_admin_settings_match_names", 1)
			return (0, None, 0)

		elif type == "settings_match_default_name_ct":
			addon.set_string(userid, text, "match_names", "match", "default_name_ct", 25, "sm_popup_admin_settings_match_names", 2)
			return (0, None, 0)

		elif type == "settings_match_default_short_name_t":
			addon.set_string(userid, text, "match_names", "match", "default_short_name_t", 5, "sm_popup_admin_settings_match_names", 3)
			return (0, None, 0)

		elif type == "settings_match_default_short_name_ct":
			addon.set_string(userid, text, "match_names", "match", "default_short_name_ct", 5, "sm_popup_admin_settings_match_names", 4)
			return (0, None, 0)

		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_match_names")

	es.addons.unregisterSayFilter(filter)