import es
import gamethread
import langlib
import os
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_text = langlib.Strings(lang_dir + "admin/settings/messages_settings_referee.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "admin/settings/popup_settings_referee.ini")

# ******************** Load ********************
def load():
	if os.path.isfile("cstrike/cfg/soccer_mod/es_soccer_mod_scoreboard_db.txt") == True:
		es.keygroupload("soccer_mod_scoreboard", "soccer_mod")
	else:
		es.keygroupcreate("soccer_mod_scoreboard")

	create_popup()

	es.addons.registerSayFilter(filter)

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_settings_scoreboard")

	popup.addline("SOCCER MOD %s" % ("SCOREBOARD SETTINGS"))
	popup.addline(" ")

	map = es.ServerVar("eventscripts_currentmap")
	if es.exists("key", "soccer_mod_scoreboard", map) == 1:
		value = es.keygetvalue("soccer_mod_scoreboard", map, "angle_x")
		if value == "":
			value = "Not set"
		popup.addline("->1. %s: %s" % ("X angle", value))

		value = es.keygetvalue("soccer_mod_scoreboard", map, "angle_y")
		if value == "":
			value = "Not set"
		popup.addline("->2. %s: %s" % ("Y angle", value))

		value = es.keygetvalue("soccer_mod_scoreboard", map, "position_x")
		if value == "":
			value = "Not set"
		popup.addline("->3. %s: %s" % ("X position", value))

		value = es.keygetvalue("soccer_mod_scoreboard", map, "position_y")
		if value == "":
			value = "Not set"
		popup.addline("->4. %s: %s" % ("Y position", value))

		value = es.keygetvalue("soccer_mod_scoreboard", map, "position_z")
		if value == "":
			value = "Not set"
		popup.addline("->5. %s: %s" % ("Z position", value))
	else:
		popup.addline("->1. %s: 0" % ("X angle"))
		popup.addline("->2. %s: 0" % ("Y angle"))
		popup.addline("->3. %s: 0" % ("X position"))
		popup.addline("->4. %s: 0" % ("Y position"))
		popup.addline("->5. %s: 0" % ("Z position"))

	popup.addline("->6. %s" % ("Get coordinate"))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(1, 7):
		popup.select(i, change_setting)

	for i in range(7, 9):
		popup.submenu(i, "sm_popup_admin_settings_scoreboard")

	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Events ********************
def es_map_start(event_var):
	popuplib.delete("sm_popup_admin_settings_scoreboard")

	create_popup()

# ******************** Popup choice ********************
def change_setting(userid, choice, name):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
		es.keycreate("sm_keygroup_set", player.steamid)

	if choice == 1:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_scoreboard_angle_x")
		es.tell(userid, "#green", "Type a value between -360 and 360.")
	elif choice == 2:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_scoreboard_angle_y")
		es.tell(userid, "#green", "Type a value between -360 and 360.")
	elif choice == 3:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_scoreboard_position_x")
		es.tell(userid, "#green", "Type a value between -100000 and 100000.")
	elif choice == 4:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_scoreboard_position_y")
		es.tell(userid, "#green", "Type a value between -100000 and 100000.")
	elif choice == 5:
		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_scoreboard_position_z")
		es.tell(userid, "#green", "Type a value between -100000 and 100000.")
	elif choice == 6:
		es.server.queuecmd("playerget viewcoord %s sm_scoreboard_x sm_scoreboard_y sm_scoreboard_z" % (userid))
		gamethread.delayed(0.01, show_coord, (userid))
		popuplib.send("sm_popup_admin_settings_scoreboard", userid)

# ******************** Say filter ********************
def filter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		text = text.strip('"')

		if type == "settings_scoreboard_angle_x":
			set_value(userid, text, -360, 360, "angle_x", 1, "X angle", "angles", "x")
			return (0, None, 0)

		elif type == "settings_scoreboard_angle_y":
			set_value(userid, text, -360, 360, "angle_y", 2, "Y angle", "angles", "y")
			return (0, None, 0)

		elif type == "settings_scoreboard_position_x":
			set_value(userid, text, -100000, 100000, "position_x", 3, "X position", "origin", "x")
			return (0, None, 0)

		elif type == "settings_scoreboard_position_y":
			set_value(userid, text, -100000, 100000, "position_y", 4, "Y position", "origin", "y")
			return (0, None, 0)

		elif type == "settings_scoreboard_position_z":
			set_value(userid, text, -100000, 100000, "position_z", 5, "Z position", "origin", "z")
			return (0, None, 0)

		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages_text(text, tokens, player.get("lang")))

def set_value(userid, text, min, max, setting, number, popup_text, entity_value, axis):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if text != "!cancel":
		error = "Type a value between %s and %s." % (min, max)
		try:
			value = int(round(float(text), 0))

			if value >= min:
				if value <= max:
					popuplib.find("sm_popup_admin_settings_scoreboard").modline(number + 2, "->%s. %s: %s" % (number, popup_text, value))

					map = es.ServerVar("eventscripts_currentmap")
					if es.exists("key", "soccer_mod_scoreboard", map) == 0:
						es.keycreate("soccer_mod_scoreboard", map)

					if entity_value == "angles":
						x = es.keygetvalue("soccer_mod_scoreboard", map, "angle_x")
						if x == "":
							x = 0

						y = es.keygetvalue("soccer_mod_scoreboard", map, "angle_y")
						if y == "":
							y = 0

						if axis == "x":
							es.entitysetvalue(es.ServerVar("sm_scoreboard_index"), entity_value, "%s %s 0" % (value, y))
						else:
							es.entitysetvalue(es.ServerVar("sm_scoreboard_index"), entity_value, "%s %s 0" % (x, value))
					else:
						x = es.keygetvalue("soccer_mod_scoreboard", map, "position_x")
						if x == "":
							x = 0

						y = es.keygetvalue("soccer_mod_scoreboard", map, "position_y")
						if y == "":
							y = 0

						z = es.keygetvalue("soccer_mod_scoreboard", map, "position_z")
						if z == "":
							z = 0

						if axis == "x":
							es.entitysetvalue(es.ServerVar("sm_scoreboard_index"), entity_value, "%s %s %s" % (value, y, z))
						elif axis == "y":
							es.entitysetvalue(es.ServerVar("sm_scoreboard_index"), entity_value, "%s %s %s" % (x, value, z))
						else:
							es.entitysetvalue(es.ServerVar("sm_scoreboard_index"), entity_value, "%s %s %s" % (x, y, value))

					es.keysetvalue("soccer_mod_scoreboard", map, setting, value)
					es.keygroupsave("soccer_mod_scoreboard", "soccer_mod")

					es.tell(userid, "#green", "%s has set %s to %s." % (player.name, popup_text, value))

					es.keydelete("sm_keygroup_set", player.steamid)
					popuplib.send("sm_popup_admin_settings_scoreboard", userid)
				else:
					es.tell(userid, "#green", error)
			else:
				es.tell(userid, "#green", error)
		except ValueError:
			es.tell(userid, "#green", error)
	else:
		es.keydelete("sm_keygroup_set", player.steamid)
		popuplib.send("sm_popup_admin_settings_scoreboard", userid)

def show_coord(userid):
	es.tell(userid, "#green", "X: %s, Y: %s, Z: %s" % (es.ServerVar("sm_scoreboard_x"), es.ServerVar("sm_scoreboard_y"), es.ServerVar("sm_scoreboard_z")))

# ******************** Unload ********************
def unload():
	if es.exists("keygroup", "soccer_mod_scoreboard") == 1:
		es.keygroupdelete("soccer_mod_scoreboard")

	popuplib.delete("sm_popup_admin_settings_scoreboard")

	es.addons.unregisterSayFilter(filter)