﻿import es
import langlib
import os
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/skins/messages_skins.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/skins/popup_skins.ini")

settings = ["t", "ct", "t_gk", "ct_gk"]

# ******************** Load ********************
def load():
	for item in settings:
		es.set("sm_skins_%s" % (item), es.ServerVar("sm_skins_default_%s" % (item)))

	popup = popuplib.create("sm_popup_admin_skins")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	for i in range(0, len(settings)):
		value = str(es.ServerVar("sm_skins_%s" % (settings[i])))
		popup.addline("->%s. %s: %s" % (i + 1, popup_text(settings[i]), value[14:len(value)]))
		popup.select(i + 1, popup_choice)

	popup.addline("->5. %s" % (popup_text("reset")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	popup.select(5, popup_choice)

	for i in range(6, 9):
		popup.submenu(i, "sm_popup_admin_skins")

	popup.submenu(9, "sm_popup_admin")

	es.keygroupcreate("sm_keygroup_skins_gk")
	es.keygroupcreate("sm_keygroup_skins_personal")

	if os.path.isfile("cstrike/cfg/soccer_mod/es_soccer_mod_skins_db.txt") == True:
		es.keygroupload("soccer_mod_skins", "soccer_mod")

# ******************** Events ********************
def player_disconnect(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		steamid = event_var["es_steamid"]

		if es.exists("key", "sm_keygroup_skins_gk", steamid) == 1:
			es.keydelete("sm_keygroup_skins_gk", steamid)

		if es.exists("key", "sm_keygroup_skins_personal", steamid) == 1:
			es.keydelete("sm_keygroup_skins_personal", steamid)

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		skin_check(event_var["userid"])

# ******************** Commands ********************
def cmd_gk():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.exists("key", "sm_keygroup_skins_gk", player.steamid) == 0:
			es.keycreate("sm_keygroup_skins_gk", player.steamid)
			es.tell(userid, "#green", messages_text("gk", None, player.get("lang")))
		else:
			es.keydelete("sm_keygroup_skins_gk", player.steamid)
			es.tell(userid, "#green", messages_text("no_gk", None, player.get("lang")))

		skin_check(userid)
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

def cmd_personal():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.exists("key", "soccer_mod_skins", player.steamid) == 1:
			if es.exists("key", "sm_keygroup_skins_personal", player.steamid) == 0:
				es.keycreate("sm_keygroup_skins_personal", player.steamid)
				es.tell(userid, "#green", messages_text("personal", None, player.get("lang")))
			else:
				es.keydelete("sm_keygroup_skins_personal", player.steamid)
				es.tell(userid, "#green", messages_text("no_personal", None, player.get("lang")))

			skin_check(userid)
		else:
			es.tell(userid, "#green", messages_text("no_personal_skin", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

# ******************** Popup choice ********************
def popup_choice(userid, choice, name):
	if choice < 5:
		open_path(userid, str("cstrike/models/player"), choice)
	else:
		number = 1
		for item in settings:
			value = es.keygetvalue("soccer_mod_settings", "skins", "default_%s" % (item))
			popuplib.find("sm_popup_admin_skins").modline((number + 2), "->%s. %s: %s" % (number, popup_text(item), value[14:len(value)]))
			es.set("sm_skins_%s" % (item), value)
			number += 1

		set_t()
		set_ct()
		set_t_gk()
		set_ct_gk()

		es.doblock("soccer_mod_2011/downloads/refresh")

		player = playerlib.getPlayer(userid)

		tokens = {}
		tokens["name"] = player.name
		lang_msg("reset", tokens)

		popuplib.send("sm_popup_admin_skins", userid)

# ******************** Easymenu choice ********************
def select_skin(userid, choice, name):
	length = len(choice)

	type = choice.split("_")
	if type[0] == "dir":
		open_path(userid, str(choice[6:length]), type[1])
	else:
		player = playerlib.getPlayer(userid)
		value = choice[15:length]

		tokens = {}
		tokens["name"] = player.name
		tokens["value"] = value[14:len(value)]

		number = int(type[1])

		if number < 5:
			es.set("sm_skins_%s" % (settings[number - 1]), value)

			if number == 1:
				set_t()

			elif number == 2:
				set_ct()

			elif number == 3:
				set_t_gk()

			elif number == 4:
				set_ct_gk()

			popuplib.find("sm_popup_admin_skins").modline(number + 2, "->%s. %s: %s" % (number, popup_text(settings[number - 1]), tokens["value"]))

			lang_msg(settings[number - 1], tokens)

			es.doblock("soccer_mod_2011/downloads/refresh")

		popuplib.send("sm_popup_admin_skins", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages_text(text, tokens, player.get("lang")))

def skin_check(userid):
	player = playerlib.getPlayer(userid)
	if player.team > 1:
		if player.team == 2:
			team = "t"
		else:
			team = "ct"

		exists = es.exists("key", "soccer_mod_skins", player.steamid)

		if exists == 1:
			value = es.keygetvalue("soccer_mod_skins", player.steamid, team)
			if value != "":
				if es.exists("key", "sm_keygroup_skins_personal", player.steamid) == 1:
					set_skin(userid, value)
				else:
					if es.exists("key", "sm_keygroup_skins_gk", player.steamid) == 1:
						set_skin(userid, es.ServerVar("sm_skins_%s_gk" % (team)))
					else:
						set_skin(userid, es.ServerVar("sm_skins_%s" % (team)))
			else:
				if es.exists("key", "sm_keygroup_skins_gk", player.steamid) == 1:
					set_skin(userid, es.ServerVar("sm_skins_%s_gk" % (team)))
				else:
					set_skin(userid, es.ServerVar("sm_skins_%s" % (team)))

		if exists == 0:
			if es.exists("key", "sm_keygroup_skins_gk", player.steamid) == 1:
				set_skin(userid, es.ServerVar("sm_skins_%s_gk" % (team)))
			else:
				set_skin(userid, es.ServerVar("sm_skins_%s" % (team)))

def set_skin(userid, model):
	es.server.queuecmd('playerset model %s "%s"' % (userid, model))

def open_path(userid, path, choice):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	myPopup = popuplib.easymenu(popup_name, None, select_skin)
	myPopup.settitle(popup_text("select"))

	dirup = path.split("/")

	length = len(dirup) - 1
	dir = ""
	for i in range(0, length):
		if i < (length - 1):
			dir += dirup[i] + "/"
		else:
			dir += dirup[i]

	if path != "cstrike/models/player":
		myPopup.addoption("dir_%s_%s" % (choice, dir), "^ %s ^" % (popup_text("up")))

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == True:
			myPopup.addoption("dir_%s_%s/%s" % (choice, path, item), "(%s) %s" % (popup_text("folder"), item))

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == False:
			type = item.split(".")
			length = len(type) - 1
			if type[length] == "mdl":
				myPopup.addoption("file_%s_%s/%s" % (choice, path, item), item)

	myPopup.submenu(10, "sm_popup_admin_skins")

	popuplib.send(popup_name, userid)

def set_t():
	set_team_skin("sm_skins_t", "#t,#alive")

def set_ct():
	set_team_skin("sm_skins_ct", "#ct,#alive")

def set_team_skin(cvar, users):
	for player in playerlib.getPlayerList(users):
		if es.exists("key", "sm_keygroup_skins_gk", player.steamid) == 0:
			set_skin(player.userid, es.ServerVar(cvar))

def set_t_gk():
	set_gk_skin("sm_skins_t_gk", "#t,#alive")

def set_ct_gk():
	set_gk_skin("sm_skins_ct_gk", "#ct,#alive")

def set_gk_skin(cvar, users):
	for player in playerlib.getPlayerList(users):
		if es.exists("key", "sm_keygroup_skins_gk", player.steamid) == 1:
			set_skin(player.userid, es.ServerVar(cvar))

# ******************** Unload ********************
def unload():
	if es.exists("keygroup", "soccer_mod_skins") == 1:
		es.keygroupdelete("soccer_mod_skins")

	es.keygroupdelete("sm_keygroup_skins_gk")
	es.keygroupdelete("sm_keygroup_skins_personal")

	popuplib.delete("sm_popup_admin_skins")